#ifndef PC_STUFF
#define PC_STUFF

#ifdef isalpha            // These may have come from Main.h
  #undef isalpha
  #undef isdigit
#endif

#ifndef __linux__
  #ifndef VCL_H
    #include <vcl.h>
  #endif
#else
  #include <pthread.h>
  #include <unistd.h>
  #include <stdio.h>
  #include <fcntl.h>
  #include <sys/stat.h>
#endif

typedef           long long  long64 ;
typedef  unsigned long long ulong64 ;


#ifndef MAIN_HEADER
  #include "../Headers.h"
#endif
#include "../UsbAccess.h"  /* AES Usb Header */
#include "../FtdiAccess.h" /* AES Ftdi Header */
#include "../HidAccess.h"  /* AES HID Header */
#ifndef __linux__
  #include "USBDevices/HidC2.h"    /* C2 Special */
  #include "USBDevices/USBF7xxx.h" /* F7xxx Special */
#endif
#include "../VcpAccess.h"  /* Comms ports */
#include "../../Configuration.h"
#include "ReadConfig.h"


#ifdef __linux__
    #define ERROR_INVALID_DATA      1
    #define ERROR_GEN_FAILURE       2
    #define ERROR_NOT_READY         3
    #define ERROR_BAD_UNIT          4
    #define ERROR_BUSY          170
    #define ERROR_DEVICE_NOT_CONNECTED  1167
#endif



#ifndef __linux__
// Data for Driver from Config system
  extern        AnsiString      Serial ;
  extern        AnsiString      LoggingFileName ;
#else
  extern        char*     Serial ;
  extern        char      LoggingFileName[256] ;
#endif
extern        int             LogFileSize ;
extern        int             BCRComPort ;

#endif